/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.3 Evaluation
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Test-LCD
Version : 6
Date    : 13/05/2010
Author  : Hoguet Marchand
Company : Thierry
Comments: Programmation Borne d'criture


Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*****************************************************/

#include <mega8535.h>      
/* the LCD module is connected to PORTC */
#asm
    .equ __lcd_port=0x15
#endasm

/* now you can include the LCD Functions */
#include <lcd.h>
#include <delay.h>     // pour la fonction delay_ms();
#include <stdio.h>     // pour la fonction sprintf();

#define CTS     PIND.4
#define BUZZER  PINA.7

// Declare your global variables here

unsigned char tampon[20], Temps1[20], Identifiant[8];
unsigned char trame, Statut, Information;
unsigned char Temps, Seconde, Minute, Heure;


void USART_Transmit( unsigned char data )
{
/* Wait for empty transmit buffer */
while ( !( UCSRA & (0x20)) ) // Test de UDRE bit 5
;
/* Put data into buffer, sends the data */
UDR = data;
}

unsigned char USART_Receive( void )
{
/* Wait for data to be received */
while ( !(UCSRA & 0x80) ) // Test de RXC bit7
;
/* Get and return received data from buffer */
return UDR;
}

// Permet de vrifier le Statut de la carte  

int VerifStatut (void)
{
	int Presence;
 	while(CTS==1);     //Attente que l'entre CTS soit active ( 0)
        trame='S';        //ou 0x53 : permet de vrifier le statut
        USART_Transmit(trame);
        Statut = USART_Receive();
    
    	if(Statut==0x96)      //Bit d'identification de la carte
        {
            Presence=1;
            sprintf(tampon,"Lecture  ");
            lcd_gotoxy(0,2);
            lcd_puts(tampon);
        }
        else
        {
            Presence=0;
            sprintf(tampon,"Pas Carte");
            lcd_gotoxy(0,2);
            lcd_puts(tampon);
        }
    return Presence;   
}
                    
void Recoit_UID (void)
{
    int i;
    unsigned char car;;
    i=0;
    while(CTS==1);
    trame='U',     //ou 0x55 : permet de lire l'UID
    USART_Transmit(trame);
    Statut = USART_Receive();
    
    while(i<=6)     // 6 pour les MIFARE 1k/4k card types
    {
        car = USART_Receive();
        Identifiant[i]=car;
        i++;
    }
} 

// Mise en place de l'interruption interne 2000 KHz permettant d'tablir le temps

interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{  
	Temps++;
	if (Temps>=100) 
	{
		Temps=0;
		Seconde++;
		if(Seconde>=10) 
		{
			Seconde=0;
			Minute++;
			if(Minute>=3)
			{
				Minute=0;
				Heure++;
				if(Heure>=99)
				{
					Heure=0;
				};
			};
		};
	}; 
}

void Horloge(void)
{
    sprintf(Temps1,"%2dh %2dmin %2ds", Heure, Minute, Seconde);
    lcd_gotoxy(0,3);
    lcd_puts(Temps1);
}


//Remise  zro synchronise
interrupt [EXT_INT1] void ext_int1_isr(void)
{
    Temps=0;
    Seconde=0;
    Minute=0;
    Heure=0;
}


//Dclenchement  la detection d'une carte
interrupt [EXT_INT0] void ext_int0_isr(void) 
{ 

}    

void EcritureTemps(int Borne)
{
    int z;
    
    while(CTS==1);
    trame='W';     //ou 0x57 : permet de lire l'UID
    USART_Transmit(trame);
    
    while(CTS==1);
    trame=Borne*18;     //Ecriture  l'adresse du numro de borne
    USART_Transmit(trame);
    
    while(CTS==1);
    trame=0x00;     //Cl de scurit  choisir entre 0 et 31 sur les 5 premiers bits de l'octet
    USART_Transmit(trame);
    
    for(z=0; z<4;z++)
    {
    	trame = Identifiant[z];
    	USART_Transmit(trame);
    }
    
    while(CTS==1);
    trame=Temps;
    USART_Transmit(trame);
    
    while(CTS==1);
    trame=Seconde;
    USART_Transmit(trame);
    
    while(CTS==1);
    trame=Minute;
    USART_Transmit(trame);
    
    while(CTS==1);
    trame=Heure;
    USART_Transmit(trame);
    
    sprintf(trame, "");
    for(z=0;z<8;z++)
    {
    	while(CTS==1);
    	USART_Transmit(trame);
    }
    
        sprintf(Information, "");
    	Information = USART_Receive();

    
}
    

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=0 State6=0 State5=0 State4=0 State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0xF0;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTC=0x00;
DDRC=0xFF;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initializatio_n
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 2000,000 kHz
// Mode: CTC top=OCR1A
// OC1A output: Toggle
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x40; // Configuration de la valeur de comparaison
TCCR1B=0x0A;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x4E; // Slectionne la base de temps sur une frquence de 2 MHz, soit un top d'horloge toutes les 0,5 us.
OCR1AL=0x20; // Une interruption quand on arrive  20 000 top d'horloge (0x4E20 soit 10 ms)
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;


// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: On
// INT1 Mode: Falling Edge
// INT2: Off
GICR|=0xC0;
MCUCR=0x0A;
MCUCSR=0x00;
GIFR=0xC0;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x10;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On                                               
// USART Mode: Asynchronous
// USART Baud rate: 9600
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x67;
 
/* initialize the LCD for 2 lines & 16 columns */
lcd_init(16);

/* switch to writing in Display RAM */
//lcd_gotoxy(0,0);
//lcd_putsf("Projet Borne RFID"); 

// initialisation des variables globales
Temps=0;
Seconde=0;
Minute=0;
Heure=0;
BUZZER=1;

// Global enable interrupts
#asm("sei")


while (1)
{
    //Dclaration des variables locales
    
    unsigned char NumeroBorneHexa;
    int Dizaine, Unite, NumeroBorne;
    int PresenceCarte, z;
    
    // Appelle de L'horloge
    Horloge();

    //Changement du numro de borne de 0  9
    
    NumeroBorneHexa = (PINA&0x0f);
    /*Dizaine=NumeroBorneHexa/10;  	//Conversion du numro de bornes Hexadcimal en Dcimal
    Unite=((int)NumeroBorneHexa)%10;
    NumeroBorne=Dizaine*10+Unite;*/
                 
    sprintf(tampon,"N borne : 0x%x", NumeroBorneHexa);
    lcd_gotoxy(0,0);   
    lcd_puts(tampon);
     
    //Vrification du statut de la carte
    
    PresenceCarte = VerifStatut ();   // Appelle de la fonction permettant de vrifier le statut
    
    if(PresenceCarte==1)
    {
        /* Possiblit de lire l'identifiant unique de la carte     */
        
        Recoit_UID();
        for(z=0;z<4;z++)
        {
        	sprintf(tampon,"%3d",Identifiant[z]);
        	lcd_gotoxy(z*4,1);   
        	lcd_puts(tampon);
        }
        
        // Ecriture du temps de passage sur la carte
        
        EcritureTemps(NumeroBorneHexa);
        
        sprintf(tampon,"%x",Information);
    	lcd_gotoxy(11,2);   
    	lcd_puts(tampon);
        
        //on attend 500 ms et on dclenche le buzzer pour marquer la fin de la lecture il faut faire attention de 
        //ne pas figer l'affichage de l'horloge
        
        BUZZER=0;       //logique inverse
        
        delay_ms(100);
        Horloge();
        
        delay_ms(100);
        Horloge();
        
        delay_ms(100);
        Horloge();
        
        delay_ms(100);
        Horloge();
        
        delay_ms(100);
        
        BUZZER=1;        
    }
}
}
