/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.3 Evaluation
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Test-LCD
Version : 3
Date    : 30/04/2010
Author  : Hoguet Marchand
Company : Thierry
Comments: Programmation mission - rception


Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*****************************************************/

#include <mega8535.h>      
/* the LCD module is connected to PORTC */
#asm
    .equ __lcd_port=0x15
#endasm

/* now you can include the LCD Functions */
#include <lcd.h>
#include <delay.h>
    
#include<stdio.h>     // sprintf ???

// Declare your global variables here
// Declare your local variables here
unsigned char a;
unsigned char tampon[20], Identifiant[8];
unsigned char trame, Statut;


void USART_Transmit( unsigned char data )
{
/* Wait for empty transmit buffer */
while ( !( UCSRA & (0x20)) ) // Test de UDRE bit 5
;
/* Put data into buffer, sends the data */
UDR = data;
}

unsigned char USART_Receive( void )
{
/* Wait for data to be received */
while ( !(UCSRA & 0x80) ) // Test de RXC bit7
;
/* Get and return received data from buffer */
return UDR;
}

// Permet de vrifier le Statu de la carte  

void VerifStatut ( unsigned char data )
{
    if(data&0x08==1)      //Si Carte identifier ou non
        {
            sprintf(tampon,"Lecture");
            lcd_gotoxy(0,1);
            lcd_puts(tampon);;
        }
        else
        {
            sprintf(tampon,"Pas de carte");
            lcd_gotoxy(0,1);
            lcd_puts(tampon);
            if((data&0x01==1)||(data&0x10==1)) //Si erreur EEPROM ou erreur RS232
            {
                sprintf(tampon,"Erreur");
                lcd_gotoxy(0,1);
                lcd_puts(tampon);
            }
        }   
}
                    
void Recoit_UID (unsigned char UID [])
{
    int i;
    unsigned char car;
    i=0;
    while(i<4)     //4 ou 7 selon les modles de cartes
    {
        car = USART_Receive();
        UID[i]=0;
        i++;
    }
}   


void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTC=0x00;
DDRC=0xFF;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On                                               
// USART Mode: Asynchronous
// USART Baud rate: 9600
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x67;
 
/* initialize the LCD for 2 lines & 16 columns */
lcd_init(16);

/* switch to writing in Display RAM */
//lcd_gotoxy(0,0);
//lcd_putsf("Projet RFID"); 




while (1)
{
      a = (PINA&0x0f);             
      sprintf(tampon,"N borne : %x",a);
      lcd_gotoxy(0,0);   
      lcd_puts(tampon);
     
      if(PIND&0x08==1)
      {
        USART_Transmit('S');     //ou 0x53 : permet de vrifier le statut
        Statut = USART_Receive();
        //sprintf(tampon,"Var= %d",variable);
        //lcd_gotoxy(0,2);
        //lcd_puts(tampon);
        
        VerifStatut (Statut);   // Appelle de la fonction permettant de vrifier le statut
        
        USART_Transmit('U');  // ou 0x55 : permet de rcuprer l'identifiant unique de la carte
        Recoit_UID(Identifiant);
        sprintf(tampon,"Var= %x",Identifiant);
        lcd_gotoxy(0,3);
        lcd_puts(tampon);
      }
}
}